require 'singleton'
require_relative 'MSP/service'
require_relative 'MSP/singleton_service'

# Managed Service Provider module
# when included it includes the correspondent correct module
# to define the method_missing based on whether the class included this modeule
# is a Singleton or not
module MSP
  def self.included(klass)
    if klass.included_modules.include? Singleton
      klass.singleton_class.send(:include, MSP::SingletonService)
    else
      klass.singleton_class.send(:include, MSP::Service)
    end
  end
end
